/**
 * Title:        Can Frame<p>
 * Description:  Encapsulation of a can frame.<p>
 * Company:      Wageningen University<p>
 * @author Jaap van Bergeijk
 * @version 1.0
 */
package com.wur.can;

public class CanFrame {
  private boolean bExtended;
  private int id;
  private int length;
  private byte[] bytes;

  public CanFrame() {
    bExtended = true;
    id = 0;
    length = 0;
    bytes = null;
  }

  public CanFrame(boolean bExtended, int id, int length, byte[] bytes) {
    this.bExtended = bExtended;
    this.id = id;
    this.length = length;
    this.bytes = new byte[length];
    for (int i=0; i<length; i++)
      this.bytes[i] = bytes[i];
  }

  public String ToString() {
    String str = new String();

    if (bExtended)
      str += "ExtID: ";
    else
      str += "StdID: ";
    str += Integer.toHexString(id);
      str += (" Len: " + length + " , ");
    for (int i=0; i<length; i++)
    {
      if (bytes[i] > 0 && bytes[i] <= 15) str += "0";
      str += (Integer.toHexString(bytes[i] & 0xFF) + " ");
    }

    return str;
  }

  public byte getSourceAddress() {
    return (byte) (id & 0xFF);
  }
}
