/**
 * Title:        Can Monitor Graphical Client<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Jaap van Bergeijk<p>
 * Company:      Wageningen University<p>
 * @author Jaap van Bergeijk
 * @version 1.0
 */
package com.wur.can;

import javax.swing.UIManager;
import java.awt.*;

public class CanMonitorClient {
  boolean packFrame = false;

  public CanMonitorClient() {
    CanMonitorClientMainWindow frame = new CanMonitorClientMainWindow();

    // Validate frames that have preset sizes
    // Pack frames that have useful preferred size info, e.g. from their layout
    if (packFrame) {
      frame.pack();
    }
    else {
      frame.validate();
    }
    // Center the window
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = frame.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    frame.setVisible(true);
  }

  public static void main(String[] args) {
    try {
      UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    CanMonitorClient canMonitorClient1 = new CanMonitorClient();
  }
}