/**
 * Title:        Can Monitor Graphical Client Main Window<p>
 * Description:  <p>
 * Copyright:    Copyright (c) Jaap van Bergeijk<p>
 * Company:      Wageningen University<p>
 * @author Jaap van Bergeijk
 * @version 1.0
 */
package com.wur.can;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.tree.*;
import java.util.*;

public class CanMonitorClientMainWindow extends JFrame {
  JPanel contentPane;
  JMenuBar menuBar1 = new JMenuBar();
  JMenu menuFile = new JMenu();
  JMenuItem menuFileExit = new JMenuItem();
  JMenu menuHelp = new JMenu();
  JMenuItem menuHelpAbout = new JMenuItem();
  ImageIcon image1;
  ImageIcon image2;
  ImageIcon image3;
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuItem jMenuItem1 = new JMenuItem();
  JMenuItem jMenuItem2 = new JMenuItem();
  JMenuItem jMenuItem3 = new JMenuItem();
  JMenuItem jMenuItem4 = new JMenuItem();
  JMenu jMenu1 = new JMenu();
  JMenuItem jMenuItem5 = new JMenuItem();
  JMenuItem jMenuItem6 = new JMenuItem();
  JMenuItem jMenuItem7 = new JMenuItem();
  JFileChooser jFileChooser1 = new JFileChooser();
  String currFileName = null;  // Full path with filename. null means new/untitled.
  boolean dirty = false;
  Document document1;
  JMenu jMenu2 = new JMenu();
  JMenuItem jMenuItem8 = new JMenuItem();
  JCheckBoxMenuItem jCheckBoxMenuItem1 = new JCheckBoxMenuItem();
  JPanel TopPanel = new JPanel();
  JButton jButton3 = new JButton();
  JButton jButton2 = new JButton();
  JButton jButton1 = new JButton();
  JToolBar toolBar = new JToolBar();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel CenterPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel BottomPanel = new JPanel();
  JLabel statusBar = new JLabel();
  BorderLayout borderLayout4 = new BorderLayout();
  JSplitPane jSplitPane1 = new JSplitPane();
  JTextArea jTextArea1 = new JTextArea();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel LeftPanel = new JPanel();

  JMenu jMenu3 = new JMenu();
  JMenuItem jMenuItem9 = new JMenuItem();
  JScrollPane jScrollPane2 = new JScrollPane();
  DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode("ISO-11783 CAN bus");
  DefaultTreeModel treeModel = new DefaultTreeModel(rootNode);
  Vector canNodes = new Vector();

  CanMonitorClientConnector canConnector = new CanMonitorClientConnector();
  JCheckBoxMenuItem jCheckBoxMenuItem2 = new JCheckBoxMenuItem();

  private class CanNodeInfo {
    public String canNodeName;
    public CanNodeInfo(String canNode) {
      canNodeName = canNode;
    }
    public String toString() {
      return canNodeName;
    }
  }

  //Construct the frame
  public CanMonitorClientMainWindow() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
      updateCaption();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  //Component initialization
  private void jbInit() throws Exception  {

/*
    createNodes(topTreeNode);
    final JTree jTree1 = new JTree(topTreeNode);
    jTree1.putClientProperty("JTree.lineStyle", "Angled");
    DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
    renderer.setClosedIcon(new ImageIcon("tree.gif"));
    renderer.setOpenIcon(new ImageIcon("tree.gif"));
    renderer.setLeafIcon(new ImageIcon("canNode.gif"));
    jTree1.setCellRenderer(renderer);
*/

    final JTree jTree1 = new JTree(treeModel);
    jTree1.setEditable(true);
    jTree1.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    jTree1.setShowsRootHandles(true);
    jTree1.putClientProperty("JTree.lineStyle", "Angled");
    DefaultTreeCellRenderer renderer = new DefaultTreeCellRenderer();
    renderer.setClosedIcon(new ImageIcon("tree.gif"));
    renderer.setOpenIcon(new ImageIcon("tree.gif"));
    renderer.setLeafIcon(new ImageIcon("canNode.gif"));
    jTree1.setCellRenderer(renderer);

    image1 = new ImageIcon(CanMonitorClientMainWindow.class.getResource("openFile.gif"));
    image2 = new ImageIcon(CanMonitorClientMainWindow.class.getResource("closeFile.gif"));
    image3 = new ImageIcon(CanMonitorClientMainWindow.class.getResource("help.gif"));
    contentPane = (JPanel) this.getContentPane();
    document1 = jTextArea1.getDocument();
    contentPane.setLayout(borderLayout1);
    this.setSize(new Dimension(800, 600));
    this.setTitle("CAN monitor on TINI");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new CanMonitorClientMainWindow_menuFileExit_ActionAdapter(this));
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    menuHelpAbout.addActionListener(new CanMonitorClientMainWindow_menuHelpAbout_ActionAdapter(this));
    jMenuItem1.setText("New");
    jMenuItem1.addActionListener(new CanMonitorClientMainWindow_jMenuItem1_actionAdapter(this));
    jMenuItem2.setText("Open");
    jMenuItem2.addActionListener(new CanMonitorClientMainWindow_jMenuItem2_actionAdapter(this));
    jMenuItem3.setText("Save");
    jMenuItem3.addActionListener(new CanMonitorClientMainWindow_jMenuItem3_actionAdapter(this));
    jMenuItem4.setText("Save As");
    jMenuItem4.addActionListener(new CanMonitorClientMainWindow_jMenuItem4_actionAdapter(this));
    jMenu1.setText("Edit");
    jMenuItem5.setText("Font");
    jMenuItem5.addActionListener(new CanMonitorClientMainWindow_jMenuItem5_actionAdapter(this));
    jMenuItem6.setText("Foreground Color");
    jMenuItem6.addActionListener(new CanMonitorClientMainWindow_jMenuItem6_actionAdapter(this));
    jMenuItem7.setText("Background Color");
    jMenuItem7.addActionListener(new CanMonitorClientMainWindow_jMenuItem7_actionAdapter(this));
    document1.addDocumentListener(new CanMonitorClientMainWindow_document1_documentAdapter(this));
    jMenu2.setText("Server");
    jMenuItem8.setText("Setup ...");
    jMenuItem8.addActionListener(new CanMonitorClientMainWindow_jMenuItem8_actionAdapter(this));
    jCheckBoxMenuItem1.setText("Connect");
    jCheckBoxMenuItem1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCheckBoxMenuItem1_actionPerformed(e);
      }
    });
    jButton3.setIcon(image3);
    jButton3.addActionListener(new CanMonitorClientMainWindow_jButton3_actionAdapter(this));
    jButton3.setToolTipText("About");
    jButton2.setIcon(image2);
    jButton2.addActionListener(new CanMonitorClientMainWindow_jButton2_actionAdapter(this));
    jButton2.setToolTipText("Close File");
    jButton1.setIcon(image1);
    jButton1.addActionListener(new CanMonitorClientMainWindow_jButton1_actionAdapter(this));
    jButton1.setToolTipText("Open File");
    TopPanel.setLayout(borderLayout2);
    CenterPanel.setLayout(borderLayout3);
    statusBar.setText(" ");
    BottomPanel.setLayout(borderLayout4);
    jTextArea1.setLineWrap(true);
    jTextArea1.setWrapStyleWord(true);
    jTextArea1.setBackground(Color.white);
    jSplitPane1.setMinimumSize(new Dimension(107, 24));
    jSplitPane1.setRightComponent(jScrollPane1);
    jMenu3.setText("CAN");
    jMenuItem9.setText("Request SA");
    jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem9_actionPerformed(e);
      }
    });
    jTree1.setMaximumSize(new Dimension(300, 72));
    jTree1.setMinimumSize(new Dimension(50, 0));
    jTree1.setPreferredSize(new Dimension(150, 72));
    jTree1.setSelectionModel(null);
    jTree1.setShowsRootHandles(true);
    jScrollPane2.setMinimumSize(new Dimension(100, 22));
    jScrollPane2.setPreferredSize(new Dimension(150, 363));
    jCheckBoxMenuItem2.setText("Frame Forwarding");
    jCheckBoxMenuItem2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jCheckBoxMenuItem2_actionPerformed(e);
      }
    });
    menuFile.add(jMenuItem1);
    menuFile.add(jMenuItem2);
    menuFile.add(jMenuItem3);
    menuFile.add(jMenuItem4);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);
    menuHelp.add(menuHelpAbout);
    menuBar1.add(menuFile);
    menuBar1.add(jMenu1);
    menuBar1.add(jMenu2);
    menuBar1.add(jMenu3);
    menuBar1.add(menuHelp);
    this.setJMenuBar(menuBar1);
    contentPane.add(TopPanel, BorderLayout.NORTH);
    TopPanel.add(toolBar, BorderLayout.CENTER);
    toolBar.add(jButton1);
    toolBar.add(jButton2);
    toolBar.add(jButton3);
    contentPane.add(CenterPanel, BorderLayout.CENTER);
    CenterPanel.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(jScrollPane1, JSplitPane.BOTTOM);
    jSplitPane1.add(jScrollPane2, JSplitPane.TOP);
    jScrollPane2.getViewport().add(jTree1, null);
    jScrollPane1.getViewport().add(jTextArea1, null);
    contentPane.add(BottomPanel, BorderLayout.SOUTH);
    BottomPanel.add(statusBar, BorderLayout.CENTER);
    jMenu1.add(jMenuItem5);
    jMenu1.add(jMenuItem6);
    jMenu1.add(jMenuItem7);
    jMenu2.add(jMenuItem8);
    jMenu2.addSeparator();
    jMenu2.add(jCheckBoxMenuItem1);
    jMenu3.add(jCheckBoxMenuItem2);
    jMenu3.add(jMenuItem9);

    jTextArea1.setFont(new Font("Monospaced", Font.PLAIN, 12));
    canConnector.addTextLogWindow(jTextArea1);
  }

  // Display the Server Setup dialog.
  void serverSetup() {
    CanMonitorClientSetupDialog dlg = new CanMonitorClientSetupDialog(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  // Display the About box.
  void helpAbout() {
    CanMonitorClientAboutBox dlg = new CanMonitorClientAboutBox(this);
    Dimension dlgSize = dlg.getPreferredSize();
    Dimension frmSize = getSize();
    Point loc = getLocation();
    dlg.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
    dlg.setModal(true);
    dlg.show();
  }

  // Handle the File|Open menu or button, invoking okToAbandon and openFile
  // as needed.
  void fileOpen() {
    if (!okToAbandon()) {
      return;
    }
    // Use the OPEN version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      // Call openFile to attempt to load the text from file into TextArea
      openFile(jFileChooser1.getSelectedFile().getPath());
    }
    this.repaint();
  }

  // Open named file; read text from file into jTextArea1; report to statusBar.
  void openFile(String fileName)
  {
    try
    {
      // Open a file of the given name.
      File file = new File(fileName);

      // Get the size of the opened file.
      int size = (int)file.length();

      // Set to zero a counter for counting the number of
      // characters that have been read from the file.
      int chars_read = 0;

      // Create an input reader based on the file, so we can read its data.
      // FileReader handles international character encoding conversions.
      FileReader in = new FileReader(file);

      // Create a character array of the size of the file,
      // to use as a data buffer, into which we will read
      // the text data.
      char[] data = new char[size];

      // Read all available characters into the buffer.
      while(in.ready()) {
        // Increment the count for each character read,
        // and accumulate them in the data buffer.
        chars_read += in.read(data, chars_read, size - chars_read);
      }
      in.close();

      // Create a temporary string containing the data,
      // and set the string into the JTextArea.
      jTextArea1.setText(new String(data, 0, chars_read));

      // Cache the currently opened filename for use at save time...
      this.currFileName = fileName;
      // ...and mark the edit session as being clean
      this.dirty = false;

      // Display the name of the opened directory+file in the statusBar.
      statusBar.setText("Opened "+fileName);
      updateCaption();
    }
    catch (IOException e)
    {
      statusBar.setText("Error opening "+fileName);
    }
  }

  // Save current file; handle not yet having a filename; report to statusBar.
  boolean saveFile()
  {
    // Handle the case where we don't have a file name yet.
    if (currFileName == null) {
      return saveAsFile();
    }

    try
    {
      // Open a file of the current name.
      File file = new File (currFileName);

      // Create an output writer that will write to that file.
      // FileWriter handles international characters encoding conversions.
      FileWriter out = new FileWriter(file);
      String text = jTextArea1.getText();
      out.write(text);
      out.close();
      this.dirty = false;
      updateCaption();
      return true;
    }
    catch (IOException e) {
      statusBar.setText("Error saving "+currFileName);
    }
    return false;
  }

  // Save current file, asking user for new destination name.
  // Report to statuBar.
  boolean saveAsFile() {
    this.repaint();
    // Use the SAVE version of the dialog, test return for Approve/Cancel
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      // Set the current file name to the user's selection,
      // then do a regular saveFile
      currFileName = jFileChooser1.getSelectedFile().getPath();
      //repaints menu after item is selected
      this.repaint();
      return saveFile();
    }
    else {
      this.repaint();
      return false;
    }
  }

  // Check if file is dirty.
  // If so get user to make a "Save? yes/no/cancel" decision.
  boolean okToAbandon() {
    if (!dirty) {
      return true;
    }
    int value =  JOptionPane.showConfirmDialog(this, "Save changes?",
                                         "Text Edit", JOptionPane.YES_NO_CANCEL_OPTION) ;

    switch (value) {
       case JOptionPane.YES_OPTION:
         // yes, please save changes
         return saveFile();
       case JOptionPane.NO_OPTION:
         // no, abandon edits
         // i.e. return true without saving
         return true;
       case JOptionPane.CANCEL_OPTION:
       default:
         // cancel
         return false;
    }
  }

    // Update the caption of the application to show the filename and its dirty state.
  void updateCaption() {
    String caption;

    if (currFileName == null) {
       // synthesize the "Untitled" name if no name yet.
       caption = "Untitled";
    }
    else {
      caption = currFileName;
    }

    // add a "*" in the caption if the file is dirty.
    if (dirty) {
      caption = "* " + caption;
    }
    caption = "CAN monitor on TINI - " + caption;
    this.setTitle(caption);
  }


  //File | Exit action performed
  public void fileExit_actionPerformed(ActionEvent e) {
    if (okToAbandon()) {
      System.exit(0);
    }
  }

  //Server | Setup action performed
  public void serverSetup_actionPerformed(ActionEvent e) {
    serverSetup();
  }

  //Help | About action performed
  public void helpAbout_actionPerformed(ActionEvent e) {
    helpAbout();
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      fileExit_actionPerformed(null);
    }
  }

  void jMenuItem5_actionPerformed(ActionEvent e) {
   // Handle the "Edit Font" menu item

   // Pick up the existing font from the text area
   // and put it into the FontChooser before showing
   // the FontChooser, so that we are editing the
   // existing / previous font.
//   fontChooser1.setSelectedFont(jTextArea1.getFont());

   // Obtain the new Font from the FontChooser.
   // First test the return value of showDialog() to
   // see if the user pressed OK.
//   if (fontChooser1.showDialog()) {

      // Set the font of jTextArea1 to the font
      // the user selected before pressing the OK button
//      jTextArea1.setFont(fontChooser1.getSelectedFont());
//   }
    //repaints menu after item is selected
    this.repaint();
    //Repaints text properly if some text is highlighted when font is changed.
    jTextArea1.repaint();
  }

  void jMenuItem6_actionPerformed(ActionEvent e) {
    // Handle the "Foreground Color" menu item
    Color color = JColorChooser.showDialog(this,"Foreground Color",jTextArea1.getForeground());
    if (color != null) {
      jTextArea1.setForeground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }

  void jMenuItem7_actionPerformed(ActionEvent e) {
    // Handle the "Background Color" menu item
    Color color = JColorChooser.showDialog(this,"Background Color",jTextArea1.getBackground());
    if (color != null) {
     jTextArea1.setBackground(color);
    }
    //repaints menu after item is selected
    this.repaint();
  }

  void jMenuItem1_actionPerformed(ActionEvent e) {
    // Handle the File|New menu item.
    if (okToAbandon()) {
      // clears the text of the TextArea
      jTextArea1.setText("");
      // clear the current filename and set the file as clean:
      currFileName = null;
      dirty = false;
      updateCaption();
    }
  }

  void jMenuItem2_actionPerformed(ActionEvent e) {
    //Handle the File|Open menu item.
    fileOpen();
  }

  void jMenuItem3_actionPerformed(ActionEvent e) {
    //Handle the File|Save menu item.
    saveFile();
  }

  void jMenuItem4_actionPerformed(ActionEvent e) {
    //Handle the File|Save As menu item.
    saveAsFile();
  }

  void jButton1_actionPerformed(ActionEvent e) {
    //Handle tool bar Open button
    fileOpen();
  }

  void jButton2_actionPerformed(ActionEvent e) {
    //Handle tool bar Save button
    saveFile();
  }

  void jButton3_actionPerformed(ActionEvent e) {
   //Handle tool bar About button
   helpAbout();
  }

  void document1_changedUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }

  void document1_insertUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }

  void document1_removeUpdate(DocumentEvent e) {
    if (!dirty) {
      dirty = true;
      updateCaption();
    }
  }

  void jCheckBoxMenuItem1_actionPerformed(ActionEvent e) {
    if (jCheckBoxMenuItem1.getState())
    {
      System.out.println("canConnector start");
      canConnector.startStatusConnection();
      canConnector.startFramesConnection();
      canConnector.start();

      // give command over status connection to open frames connection
      canConnector.openFramesConnection();
    }
    else
    {
      System.out.println("canConnector stop");

      // give command over status connection to close frames connection
      canConnector.closeFramesConnection();

      canConnector.stopThread();
    }
  }

  void jMenuItem9_actionPerformed(ActionEvent e) {
    canConnector.sendTest();
  }

  private void createNodes(DefaultMutableTreeNode top) {
//    DefaultMutableTreeNode category = null;
    DefaultMutableTreeNode canNode = null;
//    category = new DefaultMutableTreeNode("nodes");
//    top.add(category);
    // fake tractor ECU
    canNode = new DefaultMutableTreeNode(new CanNodeInfo("Tractor ECU"));
//    category.add(canNode);
    top.add(canNode);
    // fake Virtual Terminal
    canNode = new DefaultMutableTreeNode(new CanNodeInfo("KV Virtual Terminal"));
//    category.add(canNode);
    top.add(canNode);


  }

  public void addCanNode(String canNode) {
    DefaultMutableTreeNode category = null;
//    DefaultMutableTreeNode book = null;
    category = new DefaultMutableTreeNode(new CanNodeInfo(canNode));
//    topTreeNode.add(category);
//    treeModel.insertNodeInto(category);
  }

  public void newCanFrameReceived(CanFrame canFrame) {
    // output to text window
    String str = canFrame.ToString();
    jTextArea1.append(str);
    jTextArea1.append("\n");

    // check tree model
    byte sourceAddress = canFrame.getSourceAddress();
    CanNode node = new CanNode(sourceAddress);
    if (canNodes.contains(node))
    {

    }
    else
    {
      DefaultMutableTreeNode category = null;
      category = new DefaultMutableTreeNode(new CanNodeInfo(str));
//      treeModel.insertNodeInto(category);
    }
  }

  void jCheckBoxMenuItem2_actionPerformed(ActionEvent e) {
    if (jCheckBoxMenuItem2.getState())
    {
      System.out.println("Frames Connection start");

      // give command over status connection to open frames connection
      canConnector.openFramesConnection();
    }
    else
    {
      System.out.println("Frames Connection stop");

      // give command over status connection to close frames connection
      canConnector.closeFramesConnection();
    }
  }
}

class CanMonitorClientMainWindow_menuFileExit_ActionAdapter implements ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_menuFileExit_ActionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.fileExit_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_menuHelpAbout_ActionAdapter implements ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_menuHelpAbout_ActionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.helpAbout_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem5_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem5_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem5_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem6_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem6_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem6_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem7_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem7_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem7_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem1_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem1_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem1_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem2_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem2_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem2_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem3_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem3_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem3_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem4_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem4_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jMenuItem4_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jButton1_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jButton1_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jButton2_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jButton2_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_jButton3_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jButton3_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jButton3_actionPerformed(e);
  }
}

class CanMonitorClientMainWindow_document1_documentAdapter implements javax.swing.event.DocumentListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_document1_documentAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void changedUpdate(DocumentEvent e) {
    adaptee.document1_changedUpdate(e);
  }

  public void insertUpdate(DocumentEvent e) {
    adaptee.document1_insertUpdate(e);
  }

  public void removeUpdate(DocumentEvent e) {
    adaptee.document1_removeUpdate(e);
  }
}

class CanMonitorClientMainWindow_jMenuItem8_actionAdapter implements java.awt.event.ActionListener {
  CanMonitorClientMainWindow adaptee;

  CanMonitorClientMainWindow_jMenuItem8_actionAdapter(CanMonitorClientMainWindow adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.serverSetup_actionPerformed(e);
  }
}
